{ config, lib, pkgs, ... }:
let

in {
nixpkgs = {
    config = {
      allowUnfree = true;
      allowUnfreePredicate = (_: true);
    };
  };

  nix = {
    package = lib.mkDefault pkgs.nix;
    settings = {
      experimental-features = [ "nix-command" "flakes" "repl-flake" ];
      warn-dirty = false;
    };
  };
  programs = {
    home-manager.enable = true;
    git.enable = true;
    git = {
      userName = "m3tam3re";
      userEmail = "m@m3tam3re.com";
      aliases = { st = "status"; };
      extraConfig = {
        core.excludesfile = "~/.gitignore_global";
      };
    };

  };

  home = {
    username = lib.mkDefault "m3tam3re";
    homeDirectory = lib.mkDefault "/home/${config.home.username}";
  };
}
